package worldmap;
import java.awt.FlowLayout;
import java.awt.Panel;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.lang.*;
import java.util.Map;
import java.util.HashMap;
import worldmap.action.ActionButton;
import worldmap.action.ClearBoardButton;
import worldmap.action.MoveCenterButton;
import worldmap.action.RotateAction;
import worldmap.action.SimpleAction;
import worldmap.action.WorldMapChoice;
import worldmap.action.ZoomButton;

//--------------------------------------------------------------------//
/**
 * ANVǗNX
 */
public class WorldMapActionManager
  implements MouseListener,MouseMotionListener,KeyListener{

/** gEk */
  public static final double RADIUS_COEF=1.2;

/** _oxω */
  public static final double THETA_X=15.0;

/** _ܓxω */
  public static final double THETA_Y=10.0;

/** n}\LoX */
  protected WorldMapViewCanvas canvas;

/** }EXʒu */
  protected Point mousePoint;

/** ANVL[i[}bv */
  protected Map keyMap;

/** pl */
  protected Panel controlPanel;

/**
 * ANVǗIuWFNg\z
 * @param canvas n}\LoX
 */
  public WorldMapActionManager(WorldMapViewCanvas canvas){
    this.canvas=canvas;
    canvas.addMouseListener(this);
    canvas.addMouseMotionListener(this);
    canvas.addKeyListener(this);
    mousePoint=new Point();

    keyMap=new HashMap();
    controlPanel=new Panel(new FlowLayout());
    addActions();
  }

//--------------------------------------------------------------------//
/**
 * ANVǉ
 */
  protected void addActions(){
// g{^
    ActionButton zoomin=new ZoomButton("zoom in",canvas,RADIUS_COEF);
// k{^
    ActionButton zoomout=
      new ZoomButton("zoom out",canvas,1.0/RADIUS_COEF);
// Sʒuړ{^
    ActionButton moveCenter=new MoveCenterButton("move center",canvas);
// ̈於\{^
    ActionButton clearBoard=new ClearBoardButton("clear",canvas);
// ֎_]
    SimpleAction east=new RotateAction(canvas,THETA_X,0.0);
// ֎_]
    SimpleAction west=new RotateAction(canvas,-THETA_X,0.0);
// k֎_]
    SimpleAction north=new RotateAction(canvas,0.0,THETA_Y);
// 쑤֎_]
    SimpleAction south=new RotateAction(canvas,0.0,-THETA_Y);

    keyMap.put(new Integer(KeyEvent.VK_NUMPAD1),zoomin);
    keyMap.put(new Integer(KeyEvent.VK_1),zoomin);
    keyMap.put(new Integer(KeyEvent.VK_ADD),zoomin);
    keyMap.put(new Integer(KeyEvent.VK_SEMICOLON),zoomin);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD0),zoomout);
    keyMap.put(new Integer(KeyEvent.VK_0),zoomout);
    keyMap.put(new Integer(KeyEvent.VK_SUBTRACT),zoomout);
    keyMap.put(new Integer(KeyEvent.VK_MINUS),zoomout);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD5),moveCenter);
    keyMap.put(new Integer(KeyEvent.VK_5),moveCenter);
    keyMap.put(new Integer(KeyEvent.VK_C),moveCenter);
    keyMap.put(new Integer(KeyEvent.VK_D),clearBoard);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD4),east);
    keyMap.put(new Integer(KeyEvent.VK_LEFT),east);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD6),west);
    keyMap.put(new Integer(KeyEvent.VK_RIGHT),west);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD2),north);
    keyMap.put(new Integer(KeyEvent.VK_DOWN),north);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD8),south);
    keyMap.put(new Integer(KeyEvent.VK_UP),south);

    controlPanel.add(new WorldMapChoice(canvas));
    controlPanel.add(zoomin);
    controlPanel.add(zoomout);
    controlPanel.add(moveCenter);
    controlPanel.add(clearBoard);
  }

//--------------------------------------------------------------------//
/**
 * plԂ
 * @return pl
 */
  public Panel getControlPanel(){
    return controlPanel;
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    mousePoint.setLocation(e.getX(),e.getY());
    if(canvas.getModel()!=null){
      int pregion=canvas.getModel().
      	getRegion(mousePoint.x,mousePoint.y);
      canvas.getModel().addNameBoard(mousePoint.x,mousePoint.y);
      if(pregion>1){
      	canvas.repaint();
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * }EX{^𗣂̏s
 * @param e }EXANVƂCxg
 */
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXNbN̏s
 * @param e }EXANVƂCxg
 */
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgɓ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgȍs
 * @param e }EXANVƂCxg
 */
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXړ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseMoved(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXhbȌs
 * @param e }EXANVƂCxg
 */
  public void mouseDragged(MouseEvent e){
    int x=e.getX();
    int y=e.getY();
    if(canvas.getModel()!=null){
      canvas.getModel().rotate(mousePoint.x-x,y-mousePoint.y);
    }
    mousePoint.setLocation(x,y);
    canvas.repaint();
  }

//--------------------------------------------------------------------//
/**
 * L[̏s
 * @param e L[ANVƂCxg
 */
  public void keyPressed(KeyEvent e){
    Object value=keyMap.get(new Integer(e.getKeyCode()));
    if(value instanceof SimpleAction){
      ((SimpleAction)value).doAction();
    }
  }

//--------------------------------------------------------------------//
/**
 * L[𗣂̏s
 * @param e L[ANVƂCxg
 */
  public void keyReleased(KeyEvent e){
  }

//--------------------------------------------------------------------//
/**
 * L[^Cv̏s
 * @param e L[ANVƂCxg
 */
  public void keyTyped(KeyEvent e){
  }
}
