package worldmap;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.image.PixelGrabber;
import java.lang.*;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import worldmap.io.WorldMapReader;

//--------------------------------------------------------------------//
/**
 * nVAvbg (2 f[^) CNX
 * @author aG
 * @version 1.2.2
 */
public class WorldMapApplet extends Applet{

/** G[bZ[W */
  protected String message;

  public WorldMapApplet(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * Avbg
 */
  public void init(){
    setLayout(new BorderLayout());
    WorldMapModel model=getModel();
    Color bgColor=getTagColor("backgroundcolor");
    Color boardColor=getTagColor("boardcolor");
    Color textColor=getTagColor("textcolor");

    WorldMapViewCanvas canvas=new WorldMapViewCanvas
      (model,message,getTagFont(),bgColor,boardColor,textColor);
    WorldMapActionManager manager=new WorldMapActionManager(canvas);
    add(canvas,BorderLayout.CENTER);
    add(manager.getControlPanel(),BorderLayout.SOUTH);
  }

//--------------------------------------------------------------------//
/**
 * \[Xj
 */
  public void destroy(){
    removeAll();
  }

//--------------------------------------------------------------------//
/**
 * HTML ^OŎw肳ꂽ}bvf[^o
 * @return HTML ^OŎw肳ꂽ}bvf[^
 */
  public WorldMapModel getModel(){
    String mapName=getParameter("mapdata");
    if(mapName==null) mapName="wmap.dat";
    message=null;
    int pixel[]=getPixel();

    try{
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
    }
    catch(SecurityException ex){
      message=ex.toString();
      return null;
    }
    WorldMapModel model=new WorldMapModel();
    try{
      WorldMapReader reader=new WorldMapReader(model,pixel);
      reader.read(new URL(getDocumentBase(),mapName));
      return model;
    }
    catch(Exception ex){
      message=ex.toString();
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML ^OŎw肳ꂽFo
 * @param name p[^
 * @return HTML ^OŎw肳ꂽF
 */
  protected Color getTagColor(String name){
    String value=getParameter(name);
    if(value==null) return null;
    try{
      int rgb=Integer.parseInt(value,16);
      return new Color(rgb);
    }
    catch(NumberFormatException ex){
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML ^OŎw肳ꂽtHgo
 * @return HTML ^OŎw肳ꂽtHg
 */
  protected Font getTagFont(){
    String fontName=getParameter("fontname");
    if(fontName==null) fontName="Serif";

    String s=getParameter("fontstyle");
    int fontStyle=Font.PLAIN;
    if(s!=null){
      if(s.equals("bold")){
      	fontStyle=Font.BOLD;
      }
      else if(s.equals("italic")){
      	fontStyle=Font.ITALIC;
      }
    }

    s=getParameter("fontsize");
    int fontSize=14;
    try{
      fontSize=Integer.parseInt(s);
    }
    catch(NumberFormatException ex){
    }

    return new Font(fontName,fontStyle,fontSize);
  }

//--------------------------------------------------------------------//
/**
 * C[Wf[^ǂݍ
 * @return 摜̃sNZf[^
 */
  protected int[] getPixel(){
    String imageName=getParameter("image");
    if(imageName==null) return null;
    Image image=getImage(imageName);
    if(image==null) return null;
    int width=image.getWidth(this);
    int height=image.getHeight(this);
    int pixel[]=new int[width*height];
    PixelGrabber pg=new PixelGrabber(image,0,0,width,height,pixel,
      	      	      	      	     0,width);
    try{
      pg.grabPixels();
    }
    catch(InterruptedException ex){
      return null;
    }
    if(pg.status()==ABORT){
      return null;
    }
    else{
      return pixel;
    }
  }

//--------------------------------------------------------------------//
/**
 * C[Wǂݍ
 * @param imageName C[W̃t@C
 * @return ǂݍ񂾃C[W
 */
  protected synchronized Image getImage(String imageName){
    try{
      URL url=new URL(getDocumentBase(),imageName);
      Image image=getImage(url);
      MediaTracker tracker=new MediaTracker(this);
      tracker.addImage(image,0);
      tracker.waitForAll();
      return image;
    }
    catch(InterruptedException ex){
      System.out.println(ex.toString());
      return null;
    }
    catch(MalformedURLException ex){
      System.out.println(imageName+" can not find");
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * AvbgԂ
 * @return Avbg܂ޕ
 */
  public String getAppletInfo(){
    return "Applet of world map\n"
      	  +"Author K.Higuchi";
  }

//--------------------------------------------------------------------//
/**
 * ̃Avbg߂p[^Ԃ
 * @return Avbg߂p[^i[z
 */
  public String[][] getParameterInfo(){
    String info[][]=
      {{"mapdata","String","World map data file name."},
       {"fontname","String","Font name. Default is Serif."},
       {"fontstyle","int","Font style. Default is Font.PLAIN."},
       {"fontsize","int","Font size. Default is 14."},
       {"backgroundcolor","hexadecimal RGB number",
      	"The color of background."},
       {"boardcolor","hexadecimal RGB number",
      	"The color of region name view board."},
       {"textcolor","hexadecimal RGB number",
      	"The color of text."},};
    return info;
  }
}
