package worldmap;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Point2D;
import java.lang.*;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import worldmap.map.AEPMap;
import worldmap.map.ECPMap;
import worldmap.map.GlobeMap;
import worldmap.map.MollweideMap;
import worldmap.map.WorldMap;

//--------------------------------------------------------------------//
/**
 * 2 }bvf[^f
 */
public class WorldMapModel{

/** n}IuWFNg */
  protected WorldMap map;

/** }bv̈i[z */
  protected Region region[];

/** ̈於\i[ Map */
  protected Map boardMap;

/** _px */
  protected Point2D theta;

/** ݎwʒu|C^ */
  protected int pointer;

/* nVa̍ől */
  protected int rmax;

/* nVa̍ŏl */
  protected int rmin;

/**
 * 2 }bvf[^f\z
 */
  public WorldMapModel(){
    map=null;
    region=null;
    boardMap=new HashMap();
    theta=new Point2D.Double();
    pointer=0;
    rmax=Integer.MAX_VALUE;
    rmin=10;
  }

//--------------------------------------------------------------------//
/**
 * n}Ԃ
 * @return n}IuWFNg
 */
  public WorldMap getMap(){
    return map;
  }

//--------------------------------------------------------------------//
/**
 * n}ݒ肷
 * @param map n}IuWFNg
 */
  public void setMap(WorldMap map){
    this.map=map;
  }

//--------------------------------------------------------------------//
/**
 * }bv̈ݒ肷
 * @param region }bv̈i[z
 */
  public void setRegions(Region region[]){
    this.region=region;
  }

//--------------------------------------------------------------------//
/**
 * TCYݒ肷
 * @param panelSize plTCY
 */
  public void setSize(Dimension panelSize){
    map.setSize(panelSize.width,panelSize.height);
  }

//--------------------------------------------------------------------//
/**
 * nV̏aݒ肷
 * @param radius nVa
 */
  public void setInitRadius(int radius){
    map.radius=radius;
    rmax=3*radius;
    rmin=radius;
    map.setRadius(radius);
  }

//--------------------------------------------------------------------//
/**
 * nV̔aݒ肷
 * @param radius nVa
 */
  public void setRadius(int radius){
    map.setRadius(Math.max(Math.min(radius,rmax),rmin));
  }

//--------------------------------------------------------------------//
/**
 * gEk
 * @param coef ågEkW
 */
  public void zoom(double coef){
    int newRadius=(int)(coef*map.radius);
    setRadius(newRadius);
  }

//--------------------------------------------------------------------//
/**
 * \SʒuɃ|C^ݒ肷
 */
  public void setPointer(){
    if((map==null) || (theta==null)) return;
    int i=map.row/2-(int)(map.row*theta.getY()/180.0);
    int j=map.column/2+(int)(map.column*theta.getX()/360.0);
    pointer=i*map.column+j%map.column;
  }

//--------------------------------------------------------------------//
/**
 * |C^ݒ肷
 * @param pointer Vݒ肷|C^
 */
  public void setPointer(int pointer){
    this.pointer=pointer;
  }

//--------------------------------------------------------------------//
/**
 * wiFݒ肷
 * @param backgroundColor wiF
 */
  public void setBackgroundColor(Color backgroundColor){
    if(map!=null) map.setBackgroundColor(backgroundColor);
  }

//--------------------------------------------------------------------//
/**
 * _]
 * @param dtheta ]ox
 * @param dphy ]ܓx
 */
  public void rotate(int dtheta,int dphy){
    Point2D th=map.rotate(dtheta,dphy);
    rotate(th.getX(),th.getY());
  }

//--------------------------------------------------------------------//
/**
 * _]
 * @param dtheta ]ox
 * @param dphy ]ܓx
 */
  public void rotate(double dtheta,double dphy){
    double thetaX=theta.getX()+dtheta;
    while(thetaX>180.0)  thetaX-=360.0;
    while(thetaX<-180.0) thetaX+=360.0;
    double thetaY=theta.getY()+dphy;
    thetaY=Math.min(Math.max(thetaY,-90.0),90.0);
    theta.setLocation(thetaX,thetaY);
  }

//--------------------------------------------------------------------//
/**
 * _ʒuύX
 * @param thetaX _ox
 * @param thetaY _ܓx
 */
  public void setLocation(double thetaX,double thetaY){
    theta.setLocation(thetaX,thetaY);
  }

//--------------------------------------------------------------------//
/**
 * ̈於\
 */
  public void clearBoard(){
    boardMap.clear();
  }

//--------------------------------------------------------------------//
/**
 * n}̕\^Cvݒ肷
 * @param mapType n}\^Cv\
 */
  public void setMap(String mapType){
    if(mapType==null) return;
    if(mapType.equals(GlobeMap.NAME)){
      map=new GlobeMap(map);
    }
    else if(mapType.equals(ECPMap.NAME)){
      map=new ECPMap(map);
    }
    else if(mapType.equals(MollweideMap.NAME)){
      map=new MollweideMap(map);
    }
    else if(mapType.equals(AEPMap.NAME)){
      map=new AEPMap(map);
    }
  }

//--------------------------------------------------------------------//
/**
 * |C^ʒu𒆐SɈړ
 */
  public void moveCenter(){
    double x=(double)(pointer%map.column)/(double)map.column-0.5;
    double y=0.5-(double)(pointer/map.column)/(double)map.row;
    theta.setLocation(360.0*x,180.0*y);
  }

//--------------------------------------------------------------------//
/**
 * ̈ނԂ
 * @param x ʏ̓_ <i>x</i> W
 * @param y ʏ̓_ <i>y</i> W
 * @return ̈\
 */
  public int getRegion(int x,int y){
    int pointer=map.getPoint(x,y,theta);
    if(pointer>=0) this.pointer=pointer;
    return map.getRegion(pointer);
  }

//--------------------------------------------------------------------//
/**
 * n}̃sNZvZ
 * @return n}̃sNZi[z
 */
  public int[] calcMapPixel(){
    return map.calcMapPixel(region,theta);
  }

//--------------------------------------------------------------------//
/**
 * ̈於\ǉ
 * @param x ʏ̓_ <i>x</i> W
 * @param y ʏ̓_ <i>y</i> W
 */
  public void addNameBoard(int x,int y){
    int pt=getRegion(x,y);
    if(pt>1){
      boardMap.put(region[pt],new NameBoard(region[pt],pointer));
    }
  }

//--------------------------------------------------------------------//
/**
 * ̈於\
 * @param g plTCY
 * @param panelSize plTCY
 * @param boardColor wiF
 * @param textColor F
 */
  public void paintText(Graphics2D g,Dimension panelSize,
      	      	      	Color boardColor,Color textColor){
    Iterator keyItr=boardMap.keySet().iterator();
    while(keyItr.hasNext()){
      Object value=boardMap.get(keyItr.next());
      if(value instanceof NameBoard){
      	NameBoard board=(NameBoard)value;
      	Point p=map.getViewPoint(board.pointer,theta);
      	if(p!=null){
      	  board.setPaint(g.getFontMetrics(),panelSize,p);
      	  board.paintText(g,boardColor,textColor);
      	}
      }
    }
  }
}
