package worldmap;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.MemoryImageSource;
import java.lang.*;
import gui.BasicViewCanvas;

//--------------------------------------------------------------------//
/**
 * n}\LoX
 */
public class WorldMapViewCanvas extends BasicViewCanvas{

/** }bvf[^f */
  protected WorldMapModel model;

/** G[bZ[W */
  protected String message;

/** tHg */
  protected Font font;

/** ̈於\wiF */
  protected Color boardColor;

/** F */
  protected Color textColor;

/**
 * n}\LoX\z
 * @param model }bvf[^f
 * @param message G[bZ[W
 */
  public WorldMapViewCanvas(WorldMapModel model,String message){
    this(model,message,null,null,null,null);
  }

/**
 * n}\LoX\z
 * @param model }bvf[^f
 * @param message G[bZ[W
 * @param font tHg
 * @param bgColor wiF
 * @param boardColor ̈於\wiF
 * @param textColor F
 */
  public WorldMapViewCanvas(WorldMapModel model,String message,
      	      	      	    Font font,Color bgColor,
      	      	      	    Color boardColor,Color textColor){
    super();
    this.model=model;
    this.message=message;
    if(font==null){
      this.font=getFont();
    }
    else{
      this.font=font;
    }
    setColors(bgColor,boardColor,textColor);
  }

//--------------------------------------------------------------------//
/**
 * \Fݒ肷
 * @param bgColor wiF
 * @param boardColor ̈於\wiF
 * @param textColor F
 */
  protected void setColors(Color bgColor,Color boardColor,
      	      	      	   Color textColor){
    if(model!=null){
      if(bgColor==null){
      	model.setBackgroundColor(Color.BLACK);
      }
      else{
      	model.setBackgroundColor(bgColor);
      }
    }
    if(boardColor==null){
      this.boardColor=Color.WHITE;
    }
    else{
      this.boardColor=boardColor;
    }
    if(textColor==null){
      this.textColor=Color.BLACK;
    }
    else{
      this.textColor=textColor;
    }
  }

//--------------------------------------------------------------------//
/**
 * }bvf[^fԂ
 * @return }bvf[^f
 */
  public WorldMapModel getModel(){
    return model;
  }

//--------------------------------------------------------------------//
/**
 * ĕ`悷
 * @param g `悷OtBbNXReLXg
 */
  public void update(Graphics g){
    synchronized(this){
      paintMap(bg);
      g.drawImage(bgImage,0,0,this);
    }
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  public void paint(Graphics g){
    synchronized(this){
      setPaint();
      paintMap(bg);
      g.drawImage(bgImage,0,0,this);
    }
  }

//--------------------------------------------------------------------//
/**
 * ʂݒ肷
 */
  protected void setPaint(){
    super.setPaint();
    bg.setFont(font);
    if(model!=null){
      model.setSize(panelSize);
      model.setInitRadius
      	((int)(0.4*Math.min(panelSize.width,panelSize.height)));
    }
  }

//--------------------------------------------------------------------//
/**
 * }bv`悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintMap(Graphics2D g){
    if(model!=null){
      int color[]=model.calcMapPixel();
      Image image=createImage(new MemoryImageSource
      	(panelSize.width,panelSize.height,color,0,panelSize.width));
      g.drawImage(image,0,0,this);
      model.paintText(g,panelSize,boardColor,textColor);
    }
    else{
      drawErrorMessage(g,message);
    }
  }
}
