package worldmap.io;
import java.awt.Color;
import java.io.BufferedReader;
import java.lang.*;
import java.util.HashMap;
import java.util.StringTokenizer;
import fileio.TextDataReader;
import worldmap.Region;
import worldmap.WorldMapModel;
import worldmap.map.GlobeMap;

//--------------------------------------------------------------------//
/**
 * Q}bvǂݍ݃NX
 */
public class WorldMapReader extends TextDataReader{

/** Q}bvf[^f */
  protected WorldMapModel model;

/** 摜̃sNZf[^ */
  protected int basePixel[];

/**
 * Q}bvǂݍ݃IuWFNg\z
 * @param model Q}bvf[^f
 */
  public WorldMapReader(WorldMapModel model){
    this(model,null);
  }

/**
 * Q}bvǂݍ݃IuWFNg\z
 * @param model Q}bvf[^f
 * @param basePixel 摜̃sNZf[^
 */
  public WorldMapReader(WorldMapModel model,int basePixel[]){
    this.model=model;
    this.basePixel=basePixel;
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param br ̓[_[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void readData(BufferedReader br) throws Exception{
    int row=360;
    int column=720;
    int point[]=new int[column*row];
    int ii=0;
    int regionNumber=0;
    int regionIndex[]=null;
    Region region[]=null;
    HashMap regionMap=new HashMap();

    while(true){
      String line=br.readLine();
      if(line==null) break;
      StringTokenizer st=new StringTokenizer(line);
      int length=st.countTokens();
      if(length>0){
      	String word=st.nextToken().toLowerCase();
      	if(length>=3){
      	  if(word.equals("init")){
      	    double theta1=Double.parseDouble(st.nextToken());
      	    double theta2=Double.parseDouble(st.nextToken());
      	    model.setLocation(theta1,theta2);
      	  }
      	  else if(word.equals("region")){
      	    column=Integer.parseInt(st.nextToken());
      	    row=Integer.parseInt(st.nextToken());
      	    point=new int[column*row];
      	  }
      	  else{
      	    int id=Integer.parseInt(word);
      	    int rgb=Integer.parseInt(st.nextToken(),16);
      	    regionIndex[regionNumber]=id;
      	    region[regionNumber]=new Region(st.nextToken(),
      	      	      	      	      	    new Color(rgb));
      	    regionMap.put(new Integer(rgb),new Integer(regionNumber));
      	    regionNumber++;
      	  }
      	}
      	else if((length==2) && (!word.equals("image"))){
      	  int number=Integer.parseInt(word);
      	  int pt=Integer.parseInt(st.nextToken());
      	  for(int i=0;i<number;i++){
      	    point[ii]=pt;
      	    ii++;
      	  }
      	}
      	else if(length==1){
      	  int size=Integer.parseInt(word);
      	  regionIndex=new int[size];
      	  region=new Region[size];
      	}
      }
    }
    br.close();
    if(basePixel!=null){
      point=new int[basePixel.length];
      for(int i=0;i<basePixel.length;i++){
      	Integer base=new Integer(0xFFFFFF&basePixel[i]);
      	point[i]=((Integer)regionMap.get(base)).intValue();
      }
    }
    model.setRegions(region);
    model.setMap(new GlobeMap(row,column,point,Color.BLACK));
    model.setPointer();
  }
}
