package worldmap.map;
import java.awt.Color;
import java.awt.Point;
import java.awt.geom.Point2D;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * ʐ}@
 */
public class AEPMap extends WorldMap{

/** ʐ}@\ */
  public static final String NAME="AEP";

/**
 * n}IuWFNg\z
 * @param row f[^̍s̐
 * @param column f[^̗̐
 * @param point n}̈CfbNXi[z
 * @param bgColor wiF
 */
  public AEPMap(int row,int column,int point[],Color bgColor){
    super(row,column,point,bgColor);
  }

/**
 * n}IuWFNg\z
 * @param map p[^擾n}IuWFNg
 */
  public AEPMap(WorldMap map){
    super(map);
    vx=90.0/radius;
    vy=vx;
  }

//--------------------------------------------------------------------//
 /**
 * ʐ}̔aݒ肷
 * @param radius ʐ}̔a
 */
 public void setRadius(int radius){
    this.radius=radius;
    vx=90.0/radius;
    vy=vx;
  }

//--------------------------------------------------------------------//
/**
 * ʏ̓_n}̈ʒuo
 * @param x ʏ̓_ <i>x</i> W
 * @param y ʏ̓_ <i>y</i> W
 * @param theta n}̉]px
 * @return n}̈ʒu\
 */
  public int getPoint(int x,int y,Point2D theta){
    int dx=x-cx;
    int dy=cy-y;
    int r2=dx*dx+dy*dy;

    if(r2>radius*radius){               // n̕\̈O
      return OUT;
    }
    else if(r2==0){                     // S_
      int i=row/2-(int)(row*2.0*INV_360*theta.getY());
      int j=column/2+(int)(column*INV_360*theta.getX());
      return i*column+j%column;
    }
    else{
      double phy=Math.toRadians(theta.getY());
      double sphy=Math.sin(phy);
      double cphy=Math.cos(phy);
      double r=Math.sqrt((double)r2);
      double gy=(double)dy/r;
      r/=(double)radius;
      double ssd=Math.sin(Math.PI*r);
      double ccd=Math.cos(Math.PI*r);
      double ssy=sphy*ccd+cphy*ssd*gy;
      double ccy=1.0-ssy*ssy;

      if(ccy<TOLERANCE){
      	if(ssy>0.0){                    // kɓ_
      	  return 0;
      	}
      	else{                           // ɓ_
      	  return row*column-1;
      	}
      }
      else{
      	double yy=INV_PI*Math.asin(ssy);
      	double ccx=(cphy*ccd-sphy*ssd*gy)/Math.sqrt(ccy);
      	double xx=0.0;
      	if(ccx<-1.0+TOLERANCE)      xx=0.5;
      	else if(ccx<=1.0-TOLERANCE) xx=0.5*INV_PI*Math.acos(ccx);
      	if(dx<0) xx=-xx;
      	int i=row/2-(int)(row*yy);
      	int j=column/2+(int)(column*(xx+INV_360*theta.getX()));
      	return i*column+j%column;
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * n}̈ʒuɑΉʏ̓_o
 * @param point n}̈ʒu\
 * @param theta n}̉]px
 * @return ʏ̓_
 */
  public Point getViewPoint(int point,Point2D theta){
    if(point<0) return null;
    double phy=Math.toRadians(theta.getY());
    double sphy=Math.sin(phy);
    double cphy=Math.cos(phy);
    double dtheta=INV_360*theta.getX();
    double xx=(double)(point%column)/(double)column-0.5-dtheta;
    double yy=(double)(point/column)/(double)row-0.5;
    xx*=2.0*Math.PI;
    yy*=-Math.PI;
    double cosxx=Math.cos(xx);
    double cosyy=Math.cos(yy);
    double sinyy=Math.sin(yy);
    double ccd=cphy*cosxx*cosyy+sphy*sinyy;
    double ssd=1.0-ccd*ccd;
    if(ssd<TOLERANCE){
      if(ccd>0.0){
      	return new Point(cx,cy);
      }
      else{
      	return new Point(radius+cx,cy);
      }
    }
    else{
      double delta=Math.acos(ccd)/Math.PI;
      double ey=(-sphy*cosxx*cosyy+cphy*sinyy)/Math.sqrt(ssd);
      double ex=delta*Math.sqrt(1.0-ey*ey);
      ey*=delta;
      if(Math.sin(xx)<0.0) ex=-ex;
      int gx=(int)(radius*ex)+cx;
      int gy=-(int)(radius*ey)+cy;
      return new Point(gx,gy);
    }
  }
}
