package worldmap.map;
import java.awt.Color;
import java.awt.Point;
import java.awt.geom.Point2D;
import java.lang.*;
import figure.Point3D;
import figure.SphericalAngle;

//--------------------------------------------------------------------//
/**
 * nV
 */
public class GlobeMap extends WorldMap{

/** nV\ */
  public static final String NAME="Globe";

/** _px */
  protected SphericalAngle sa;

/**
 * n}IuWFNg\z
 * @param row f[^̍s̐
 * @param column f[^̗̐
 * @param point n}̈CfbNXi[z
 * @param bgColor wiF
 */
  public GlobeMap(int row,int column,int point[],Color bgColor){
    super(row,column,point,bgColor);
    sa=new SphericalAngle();
  }

/**
 * n}IuWFNg\z
 * @param map p[^擾n}IuWFNg
 */
  public GlobeMap(WorldMap map){
    super(map);
    vx=90.0/radius;
    vy=vx;
    sa=new SphericalAngle();
  }

//--------------------------------------------------------------------//
/**
 * nV̔aݒ肷
 * @param radius nV̔a
 */
  public void setRadius(int radius){
    this.radius=radius;
    vx=90.0/radius;
    vy=vx;
  }

//--------------------------------------------------------------------//
/**
 * ʏ̓_n}̈ʒuo
 * @param x ʏ̓_ <i>x</i> W
 * @param y ʏ̓_ <i>y</i> W
 * @param theta n}̉]px
 * @return n}̈ʒu\
 */
  public int getPoint(int x,int y,Point2D theta){
    int dx=x-cx;
    int dy=cy-y;
    int radius2=radius*radius;
    int r2=radius2-(dx*dx+dy*dy);
    if(r2<0) return OUT;                        // n̕\̈O

    double phy=Math.toRadians(theta.getY());
    double sphy=Math.sin(phy);
    double cphy=Math.cos(phy);
    double r=Math.sqrt((double)r2);
    double ssy=sphy*r+cphy*(double)dy;
    double ccy=(double)radius2-ssy*ssy;

    if(ccy<TOLERANCE){
      if(ssy>0.0){                              // kɓ_
      	return 0;
      }
      else{                                     // ɓ_
      	return row*column-1;
      }
    }
    else{
      double yy=INV_PI*Math.asin(ssy/(double)radius);
      double ccx=(cphy*r-sphy*(double)dy)/Math.sqrt(ccy);
      double xx=0.0;
      if(ccx<-1.0+TOLERANCE)      xx=0.5;
      else if(ccx<=1.0-TOLERANCE) xx=0.5*INV_PI*Math.acos(ccx);
      if(dx<0) xx=-xx;
      int i=row/2-(int)(row*yy);
      int j=column/2+(int)(column*(xx+INV_360*theta.getX()));
      return i*column+j%column;
    }
  }

//--------------------------------------------------------------------//
/**
 * n}̈ʒuɑΉʏ̓_o
 * @param point n}̈ʒu\
 * @param theta n}̉]px
 * @return ʏ̓_
 */
  public Point getViewPoint(int point,Point2D theta){
    if(point<0) return null;
    sa.set(Math.toRadians(theta.getX()),Math.toRadians(theta.getY()));

    double rx=2.0*Math.PI*((double)(point%column)/(double)column-0.5);
    double ry=Math.PI*((double)(point/column)/(double)row-0.5);
    double cry=Math.cos(ry);
    Point3D p=new Point3D(Math.cos(rx)*cry,
      	      	      	  Math.sin(rx)*cry,
      	      	      	  Math.sin(ry));
    sa.rotate(p);

    int gx=(int)(radius*p.x)+cx;
    int gy=(int)(radius*p.y)+cy;
    int gz=(int)(radius*p.z);
    if(gz<0) return null;
    else     return new Point(gx,gy);
  }
}
