package worldmap.map;
import java.awt.Color;
import java.awt.Point;
import java.awt.geom.Point2D;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * Cf}@
 */
public class MollweideMap extends WorldMap{

/** Cf}@\ */
  public static final String NAME="Mollweide";

/** Cf}@̕\ */
  protected int molWidth;

/** Cf}@̕\ */
  protected int molHeight;

/**
 * n}IuWFNg\z
 * @param row f[^̍s̐
 * @param column f[^̗̐
 * @param point n}̈CfbNXi[z
 * @param bgColor wiF
 */
  public MollweideMap(int row,int column,int point[],
      	      	      Color bgColor){
    super(row,column,point,bgColor);
  }

/**
 * n}IuWFNg\z
 * @param map p[^擾n}IuWFNg
 */
  public MollweideMap(WorldMap map){
    super(map);
  }

//--------------------------------------------------------------------//
/**
 * TCYݒ肷
 * @param width \pl̕
 * @param height \pl̍
 */
  public void setSize(int width,int height){
    super.setSize(width,height);
    molWidth=(int)(0.8*width);
    molHeight=(int)(0.8*height);
    vx=360.0/(double)molWidth;
    vy=0.0;
  }

//--------------------------------------------------------------------//
/**
 * aݒ肷<br>
 * ̐}@ł͉Ȃ
 * @param radius a
 */
  public void setRadius(int radius){
  }

//--------------------------------------------------------------------//
/**
 * ʏ̓_n}̈ʒuo
 * @param x ʏ̓_ <i>x</i> W
 * @param y ʏ̓_ <i>y</i> W
 * @param theta n}̉]px
 * @return n}̈ʒu\
 */
  public int getPoint(int x,int y,Point2D theta){
    int ix=2*(x-cx);
    int iy=2*(cy-y);
    double gx=(double)ix/(double)molWidth;
    double gy=(double)iy/(double)molHeight;
    double r2=gx*gx+gy*gy;

    if(r2>1.0){                 // n̕\̈O
      return OUT;
    }
    else if(iy>=molHeight){     // kɓ_
      return 0;
    }
    else if(iy+molHeight<=0){   // ɓ_
      return row*column-1;
    }
    else{
      double xx=gx/Math.sqrt(1.0-gy*gy);
      double yy=2.0*Math.asin(gy);
      yy=Math.asin(INV_PI*(yy+Math.sin(yy)));
      int i=row/2-(int)(row*INV_PI*yy);
      int j=column/2+(int)(column*(0.5*xx+INV_360*theta.getX()));
      return i*column+j%column;
    }
  }

//--------------------------------------------------------------------//
/**
 * n}̈ʒuɑΉʏ̓_o
 * @param point n}̈ʒu\
 * @param theta n}̉]px
 * @return ʏ̓_
 */
  public Point getViewPoint(int point,Point2D theta){
    if(point<0) return null;
    double dtheta=INV_360*theta.getX();
    double xx=2.0*((double)(point%column)/(double)column-0.5-dtheta);
    if(xx>1.0)       xx-=2.0;
    else if(xx<-1.0) xx+=2.0;
    int py=point/column;
    double aa=Math.PI;
    if(py==0){
      aa=-Math.PI;
    }
    else if(py!=row-1){
      aa=Math.PI*((double)py/(double)(row-1)-0.5);
      aa=KeplerFunction.eccentricAnomaly(Math.PI*Math.sin(aa),-1.0);
    }
    double ey=Math.sin(0.5*aa);
    double ex=xx*Math.sqrt(1.0-ey*ey);
    int gx=(int)(0.5*molWidth*ex)+cx;
    int gy=(int)(0.5*molHeight*ey)+cy;
    return new Point(gx,gy);
  }
}
