package worldmap.map;
import java.awt.Color;
import java.awt.Point;
import java.awt.geom.Point2D;
import java.lang.*;
import worldmap.Region;

//--------------------------------------------------------------------//
/**
 * n}NX
 */
public abstract class WorldMap implements Cloneable{

/** n}̗̈O\ */
  public static final int OUT=-1;

/**  */
  public static final double TOLERANCE=1.0E-4;

/** 360 ̋t */
  public static final double INV_360=1.0/360.0;

/** ΂̋t */
  public static final double INV_PI=1.0/Math.PI;

/** ʕ */
  public int width;

/** ʍ */
  public int height;

/** ʒS<i>x</i>W */
  public int cx;

/** ʒS<i>y</i>W */
  public int cy;

/** nVa */
  public int radius;

/** f[^̍s̐ */
  public int row;

/** f[^̗̐ */
  public int column;

/** n}f[^i[z */
  protected int point[];

/** wiF */
  public Color bgColor;

/** <i>x</i> ̉]xW */
  protected double vx;

/** <i>y</i> ̉]xW */
  protected double vy;

/**
 * n}IuWFNg\z
 * @param row f[^̍s̐
 * @param column f[^̗̐
 * @param point n}̈CfbNXi[z
 * @param bgColor wiF
 */
  protected WorldMap(int row,int column,int point[],
      	      	     Color bgColor){
    this.row=row;
    this.column=column;
    this.point=point;
    this.bgColor=bgColor;
    vx=0.0;
    vy=0.0;
  }

/**
 * n}IuWFNg\z
 * @param map p[^擾n}IuWFNg
 */
  protected WorldMap(WorldMap map){
    this(map.row,map.column,map.point,map.bgColor);
    setSize(map.width,map.height);
    radius=map.radius;
  }

//--------------------------------------------------------------------//
/**
 * ʏ̓_n}̈ʒuo
 * @param x ʏ̓_ <i>x</i> W
 * @param y ʏ̓_ <i>y</i> W
 * @param theta n}̉]px
 * @return n}̈ʒu\
 */
  public abstract int getPoint(int x,int y,Point2D theta);

/**
 * n}̈ʒuɑΉʏ̓_o
 * @param point n}̈ʒu\
 * @param theta n}̉]px
 * @return ʏ̓_
 */
  public abstract Point getViewPoint(int point,Point2D theta);

//--------------------------------------------------------------------//
/**
 * TCYݒ肷
 * @param width \pl̕
 * @param height \pl̍
 */
  public void setSize(int width,int height){
    this.width=width;
    this.height=height;
    cx=width/2;
    cy=height/2;
  }

//--------------------------------------------------------------------//
/**
 * aݒ肷
 * @param radius a
 */
  public void setRadius(int radius){
    this.radius=radius;
  }

//--------------------------------------------------------------------//
/**
 * wiFԂ
 * @return wiF
 */
  public Color getBackgroundColor(){
    return bgColor;
  }

//--------------------------------------------------------------------//
/**
 * wiFݒ肷
 * @param bgColor wiF
 */
  public void setBackgroundColor(Color bgColor){
    this.bgColor=bgColor;
  }

//--------------------------------------------------------------------//
/**
 * ̈ނԂ
 * @param x ʏ̓_ <i>x</i> W
 * @param y ʏ̓_ <i>y</i> W
 * @param theta n}̉]px
 * @return ̈\
 */
  public int getRegion(int x,int y,Point2D theta){
    return getRegion(getPoint(x,y,theta));
  }

//--------------------------------------------------------------------//
/**
 * ̈CfbNXԂ
 * @param pointer ʏ̓_̃|C^
 * @return w肳ꂽʒü̗CfbNX
 */
  public int getRegion(int pointer){
    if(pointer>=0){
      return point[pointer];
    }
    else{
      return pointer;
    }
  }

//--------------------------------------------------------------------//
/**
 * ]pxԂ
 * @param dtheta ʏł̈ړʂ <i>x</i> 
 * @param dphy ʏł̈ړʂ <i>y</i> 
 */
  public Point2D rotate(int dtheta,int dphy){
    return new Point2D.Double(vx*(double)dtheta,vy*(double)dphy);
  }

//--------------------------------------------------------------------//
/**
 * n}摜̃sNZԂ
 * @param region ̈i[z
 * @param theta n}̉]px
 * @return ʃsNZ̔z
 */
  public int[] calcMapPixel(Region region[],Point2D theta){
    int ii=0;
    int pixel[]=new int[width*height];
    int bgRGB=bgColor.getRGB();
    for(int j=0;j<height;j++){
      for(int i=0;i<width;i++){
      	int jj=getPoint(i,j,theta);
      	if(jj<0) pixel[ii]=bgRGB;
      	else     pixel[ii]=region[point[jj]].getColor().getRGB();
      	ii++;
      }
    }
    return pixel;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      WorldMap wmap=(WorldMap)super.clone();
      wmap.point=new int[point.length];
      System.arraycopy(point,0,wmap.point,0,point.length);
      return wmap;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int bit=31*row+column;
    for(int i=0;i<point.length;i++){
      bit=31*bit+point[i];
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNgNXɑ
 *         lꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof WorldMap){
      WorldMap wmap=(WorldMap)obj;
      if(!getClass().toString().equals(wmap.getClass().toString()))
      	return false;
      if(point.length!=wmap.point.length) return false;
      for(int i=0;i<point.length;i++){
      	if(point[i]!=wmap.point[i]) return false;
      }
      return ((row==wmap.row) && (column==wmap.column));
    }
    return false;
  }
}
